package data;

import java.awt.*;

/*
 *
 * DataDialogEditDlg
 *
 */

class DataDialogEditDlg extends Dialog implements Runnable
{
	CheckboxGroup grpType = new CheckboxGroup();
	
	Checkbox chkEquation = new Checkbox( "Equation", grpType, true );
	Checkbox chkHelper = new Checkbox( "Parameter", grpType, false );

	Button btnOk = new Button( "Ok" );
	Button btnCancel = new Button( "Cancel" );

	TextField txtName = new TextField( "x" );
	Label lblName = new Label( "x'=" );
	
	TextField txtEquation = new TextField();

	String sOrigin = "0.0";
	TextField txtOrigin = new TextField( sOrigin, 5 );

	Thread tUpdater;

	DataDialog	parentDialog;
	int			nEditIndex;

	public DataDialogEditDlg(Frame  parent, int index )
	{
		super( parent, "Edit Equation", true );

		parentDialog = (DataDialog)parent;
		nEditIndex = index;

		resize( 400, 200 );
		// setResizable( false );

		Label lbl;
		Panel pnl;

		setLayout( new BorderLayout() );

		pnl = new Panel();

		GridBagLayout layout = new GridBagLayout();
		GridBagConstraints cons = new GridBagConstraints();

		pnl.setLayout( layout );

		cons.anchor = 	GridBagConstraints.WEST;
		cons.insets = new Insets( 5, 5, 5, 5 );

		// Typ der Gleichung
		lbl = new Label( "Type:" );
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( chkEquation, cons );
		pnl.add( chkEquation );

		layout.setConstraints( chkHelper, cons );
		pnl.add( chkHelper );

		String sId = (String)parentDialog.sId.elementAt( nEditIndex );
		String sBody = (String)parentDialog.sBody.elementAt( nEditIndex );
		Double doubleOrigin = (Double)parentDialog.elementOrigin.elementAt( nEditIndex );

		txtName.setText( sId.substring(0,1) );
		txtEquation.setText( sBody );

		sOrigin = doubleOrigin.toString();
		txtOrigin.setText( sOrigin );

		if( sId.length() < 2 ) 
		{
		 	chkHelper.setState( true );
			txtOrigin.setText( "" );
			txtOrigin.setEditable( false );
		}

		chkEquation.disable();
		chkHelper.disable();

		// Eingabe des Variablennamens
		lbl = new Label( "Variable:" );
		cons.gridy = 2;
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( txtName, cons );
		pnl.add( txtName );

		txtName.disable();

		// Eingabe der Gleichung
		cons.gridy = 3;
		layout.setConstraints( lblName, cons );
		pnl.add( lblName );

		cons.weightx = 1;
		cons.fill = GridBagConstraints.HORIZONTAL;
		cons.gridwidth = 2;
		layout.setConstraints( txtEquation, cons );
		pnl.add( txtEquation );

		// Ursprung fr Iteration
		cons.gridy = 4;
		cons.weightx = 0;
		cons.gridwidth = 1;
		cons.fill = GridBagConstraints.NONE;
		lbl = new Label( "Start:" );
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( txtOrigin, cons );
		pnl.add( txtOrigin );

		add( "Center", pnl );

		// Ok, Abbrechen
		pnl = new Panel();
		pnl.setLayout( new GridLayout( 1, 2, 15, 15 ) );

		pnl.add( btnOk );
		pnl.add( btnCancel );

		add( "South", pnl );

		// damit die Felder zusammenarbeiten wird ein
		// eigener Thread gestartet
		tUpdater = new Thread( this );

		tUpdater.start();
		
		// alle Eingabefelder komplett!!!
		show();
	}

	public boolean action( Event evt, Object what ) 
	{
		if( evt.target instanceof Button )
		{
			String str = (String)what;

			if( str.equals( btnOk.getLabel() ) )
			{
				// tUpdater.stop();
				Double doubleOrigin;

				if( chkEquation.getState() )
					doubleOrigin = Double.valueOf( txtOrigin.getText() );
				else
					doubleOrigin = new Double( 0.0 );

				parentDialog.editEquation( nEditIndex, txtEquation.getText(), doubleOrigin.doubleValue() );
				
				hide();
				dispose();
				return true;
			}
			if( str.equals( btnCancel.getLabel() ) )
			{
				// tUpdater.stop();

				hide();
				dispose();
				return true;
			}
		}

		return false;
	}

	int counter = 0;

    public void run()	
	{
		for(;;)
		{
			String sName = txtName.getText();

			if( sName.length() == 0 ) sName = "x";

			// ist es eine Gleichung oder nur
			// eine Hilfsvariable
			String sType = chkEquation.getState()? "'" : "";

			lblName.setText( sName + sType + "=" );

			try
			{
				Thread.sleep(100);
			}catch( Exception e ) {}
		}
	}
}

